include graphics.e


global sequence cg_charset

integer fn, count
count = 0
cg_charset = {}

fn = open("charrom.dat","rb")

-- read the c64 charset into memory

for char = 1 to 512 by 1 do
    cg_charset = cg_charset & {{0,0,0,0,0,0,0,0}}
    for byte = 1 to 8 by 1 do
	cg_charset[char][byte] = getc(fn)
	if cg_charset[char][byte] = -1 then
	    puts(1,"Warning.  charrom.dat is too short!")
	    puts(1," It should be 4096 bytes!\n")
	    puts(1,"charrom.dat is a c64 charset rom image file.\n\n")
	    abort (1)
	end if
    end for
end for



global procedure cg_puts(atom color, sequence x)

sequence expord, bits, where, s
integer byte, byteline

expord = {4,8,2,6,1,7,3,5}
for t = 1 to length(x) by 1 do
    byteline=0
    where = get_position()
    puts(1,"*")
    s = video_config()
    if s[VC_XPIXELS]>0 then
	--put a character out there.
	
	for byter = 1 to 8.1 by 8/(s[VC_YPIXELS]/s[VC_LINES]) do
	    byte=floor(byter)
	    if byter-floor(byter)>.5 then
		byte=byte+1
	    end if
	    bits={0,0,0,0,0,0,0,0}
	    for bit = 7 to 0 by -1 do
		if and_bits(cg_charset[x[t]][byte],power(2,bit))=
		    power(2,bit) then
		    bits[8-bit]=1
		end if
	    end for 
	    for bit = 1 to 8 by 1 do
		bits[bit]={bits[bit]}
	    end for
	    while length(bits) < s[VC_XPIXELS]/s[VC_COLUMNS] do
		for bit = 1 to 8 by 1 do
		    if length(bits) < s[VC_XPIXELS]/s[VC_COLUMNS] then
			bits[expord[bit]]=bits[expord[bit]] & 
			    bits[expord[bit]][1]
		    end if
		end for
	    end while
	    bits=bits[1]&bits[2]&bits[3]&bits[4]&bits[5]&bits[6]&
		 bits[7]&bits[8]
	    pixel(bits*color,{s[VC_XPIXELS]/s[VC_COLUMNS]*(where[2]-1),
		 s[VC_YPIXELS]/s[VC_LINES]*(where[1]-1)+byteline})
	    byteline=byteline+1
	end for
    end if
end for
end procedure
